### $Header: /cvsroot/PyWX/PyWX/00-python.tcl,v 1.10 2000/08/25 22:00:23 mhagger Exp $
###
### See included file COPYRIGHT for copyright and license information.
###

set python_pages_enabled \
    [ns_config -bool ns/server/[ns_info server] EnablePythonPages]

# The ACS system defines some things differently.  Try to determine if
# we're running under ACS.
set using_acs [expr {[info commands ad_register_proc] != ""}]
if {$using_acs} {
    ns_log Notice "We appear to be running under ACS"
} else {
    ns_log Notice "We do not appear to be running under ACS"
}

proc ns_sourcepython {ignored} {
    ns_log Debug "++++ Called ns_sourcepython ([ns_conn url])"
    ns_python exec "import pywx; pywx.fulfill_request()"
}

if {$python_pages_enabled} {
    ns_log Notice "Enabling python pages (in 00-python.tcl)"
    if {$using_acs} {
	ns_log Notice "Registering ns_sourcepython using ad_register_proc"
	ad_register_proc GET /*.py ns_sourcepython
	ad_register_proc POST /*.py ns_sourcepython
	ad_register_proc HEAD /*.py ns_sourcepython
    } else {
	ns_log Notice "Registering ns_sourcepython using ns_register_proc"
	ns_register_proc GET /*.py ns_sourcepython
	ns_register_proc POST /*.py ns_sourcepython
	ns_register_proc HEAD /*.py ns_sourcepython
    }
}

