### $Header: /cvsroot/PyWX/PyWX/00-webkit.tcl,v 1.3 2000/05/23 22:24:59 titus Exp $
###
### See included file COPYRIGHT for copyright and license information.
###
### Note that the Python code here was taken from the WebKit CGI adaptor.
###


# To enable WebKit, put this file in the Tcl library directory for the
# server and add the following lines to your server config file:

# (under ns/server/servername:)
#   ns_param   EnableWebKit       1
#
# (later on:)
#   ns_section "ns/environment/WebKit"
#   ns_param  urlroot                /WebKit      
#   ns_param  pageroot               ${home}/servers/${server}/WebKit

set webkit_enabled [ns_config -bool ns/server/[ns_info server] EnableWebKit]

if {$webkit_enabled == "1"} {
    ns_log Notice "Enabling webkit interface (in 00-webkit.tcl)"
    
    set WebKitUrl [ns_config ns/environment/WebKit UrlRoot]

    ns_register_proc GET $WebKitUrl ns_webkit
    ns_register_proc POST $WebKitUrl ns_webkit
    ns_register_proc HEAD $WebKitUrl ns_webkit
}

proc ns_webkit {conn ignored} {
    set WebKitUrl [ns_config ns/environment/WebKit UrlRoot]
    set WebKitDir [ns_config ns/environment/WebKit PageRoot]

    set url [ns_conn url $conn]

    ns_python exec "

WebKitDir = '''$WebKitDir'''	# from Tcl
WebKitUrl = '''$WebKitUrl'''
url = '''$url'''

import sys, string, os, traceback
from time import asctime, localtime, time

os.chdir(WebKitDir)

import CGIAdaptor

pos = string.find(url, WebKitUrl) + len(WebKitUrl)
script = url\[pos:\]

os.environ\['REQUEST_URI'\] = url
os.environ.data\['PATH_INFO'\] = script

try:
        CGIAdaptor.main()
except:

        sys.stderr.write('\[%s\] \[error\] WebKit: Error in adaptor\\n' % asctime(localtime(time())))
        sys.stderr.write('Error while executing script\\n')
        traceback.print_exc(file=sys.stderr)

        output = apply(traceback.format_exception, sys.exc_info())
        output = string.join(output, '')
        output = string.replace(output, '&', '&amp;')
        output = string.replace(output, '<', '&lt;')
        output = string.replace(output, '>', '&gt;')
        sys.stdout.write('''Content-type: text/html

<html><body>
<p>ERROR
<p><pre>%s</pre>
</body></html>\\n''' % output)

"
}
