import sys, traceback, os, tempfile, cStringIO
from ns_python import *
import rexec
import cgi, urllib

ns_redirect()                           # redirect output thru ns_write

interactive = 0                         # default: noninteractive

form = cgi.FieldStorage()

if form.has_key("interactive"):
    interactive = form['interactive'].value

# set up dictionary for page output:
pageDict = {}

if form.has_key('code'):
    pageDict['code'] = form['code'].value
else:
    pageDict['code'] = ""               # empty string if doesn't exist;
    interactive = 1                     # switch to interactive mode

pageDict['output'] = ""
pageDict['errors'] = ""

# create a temporary file, write code to it:
tempfile.tempdir = '/tmp'
tempfile.template = 'interactive.py.'
tempfilename = tempfile.mktemp()

tempf = open(tempfilename, 'w')
tempf.write(pageDict['code'])
tempf.close()

# trap output (to stdout):
old_stdout = sys.stdout
trap_stdout = cStringIO.StringIO()
sys.stdout = trap_stdout

# execute in a restricted environment

restricted = rexec.RExec()
try:
    restricted.r_execfile(tempfilename)
except:
    type, value, trace = sys.exc_info()

    l = traceback.format_exception(type, value, trace)
    fulltrace = ''
    for i in l:
        fulltrace = fulltrace + i
                                       
        tracestr = "<b><font color=red>Errors occurred!</font></b><blockquote><pre>%s</pre></blockquote>" % \
                           fulltrace

        pageDict['errors'] = tracestr

sys.stdout = old_stdout
pageDict['output'] = trap_stdout.getvalue()

# define some formatting stuff:

if interactive != '0':
    pageDict['form'] = """
<form method=post>
<input type=hidden name=interactive value=1>
<b>Enter Python code to execute:</h2>
<textarea name=code rows=5 cols=60>%s</textarea><br>
<input type=submit value=evaluate>
</form>
""" % pageDict['code']
else:
    pageDict['form'] = """
<form method=post>
<input type=hidden name=code value=%s>
<input type=hidden name=interactive value=1>
<input type=submit value="switch to interactive mode">
</form>
""" % urllib.urlencode({ 'code': pageDict['code'] })


print """
<title>Python code evaluation page</title>
<body bgcolor=white>
<h2>Python code evaluation page</h2>
<hr>
%(form)s
<hr>
<b>Code executed:</b>
<blockquote>
<pre>
%(code)s
</pre>
</blockquote>
<b>Output:</b>
<blockquote>
<pre>
%(output)s
</pre>
</blockquote>
%(errors)s
</blockquote>

<p>
<hr>
""" % pageDict

try:                                    # If no file exists (e.g. empty)
    os.unlink(tempfilename)
except:
    pass
